#ifndef LEMOMUXDIALOG_H
#define LEMOMUXDIALOG_H

#include <QDialog>
#include <QMap>

#include "base/DeviceIndex.h"
#include "AdcLemoMux/AdcLemoMuxConfig.h"
#include "AdcLemoMux/AdcLemoMuxBuildParams.h"

struct DeviceIndexEnabledMap;

namespace Ui {
class LemoMuxDialog;
}

class LemoMuxDialog : public QDialog
{
    Q_OBJECT

public:
    explicit LemoMuxDialog(QWidget *parent = nullptr);
    ~LemoMuxDialog();

public slots:
    void setDevices(const DeviceIndexEnabledMap &map);
    void setAdcLemoMuxBp(const DeviceIndex &index, const AdcLemoMuxBuildParams &bp);

private slots:
    void on_comboBoxOut_currentIndexChanged(int index);
    void on_comboBoxIn_currentIndexChanged(int index);

signals: void adcLemoMuxConfigChanged(const AdcLemoMuxCtrlConfig &) const;
public slots: virtual void setAdcLemoMuxConfig(const AdcLemoMuxCtrlConfig &config);

private:
    void restoreGui();
    void updateComboBoxOutList();
    void updateComboBoxInList();

    Ui::LemoMuxDialog *ui;

//    DeviceIndexSet devSet; // unused yet
    QMap<DeviceIndex, AdcLemoMuxBuildParams> devBp;
    AdcLemoMuxCtrlConfig config;
};

#endif // LEMOMUXDIALOG_H
