#include "FileWatcherConfigConverter.h"

#include "FileWatcherConfig.h"

constexpr const char *k_allowRemoteControl = "allowRemoteControl";
constexpr const char *k_filePath = "filePath";

// ===================== FileWatcherConfig Start =====================

template<>
bool AbstractConfigConverter<FileWatcherConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<FileWatcherConfig>::toJsonObject(const FileWatcherConfig &in)
{
    QVariantMap m;
    m[k_allowRemoteControl] = QVariant::fromValue(in.allowRemoteControl);
    m[k_filePath] = QVariant::fromValue(in.filePath);
    return fromVariantMap(m);
}

template<>
FileWatcherConfig AbstractConfigConverter<FileWatcherConfig>::fromJsonObject(const QJsonObject &m)
{
    FileWatcherConfig out;
    update_value(m, k_allowRemoteControl, &out.allowRemoteControl);
    update_value(m, k_filePath, &out.filePath);
    return out;
}

template<>
QJsonValue AbstractConfigConverter<FileWatcherConfig>::toJsonValue(const FileWatcherConfig &in)
{
    return toJsonObject(in);
}

template<>
FileWatcherConfig AbstractConfigConverter<FileWatcherConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<FileWatcherConfig>::registerSubTypes()
{
}

// ===================== FileWatcherConfig End =====================
