#include "HrbConfigDb.h"

#include "HrbAppConfigConverter.h"

HrbConfigDb::HrbConfigDb(QObject *parent):
    AbstractConfigDb(parent)
{
    AbstractConfigConverter<HrbAppConfig>::registerTypes();
}

void HrbConfigDb::setConfig(const ConfigKey &, const HrbAppConfig &newConfig)
{
    if(!initialized)
        return;
    if (newConfig == config)
        return;
    config = newConfig;

    auto json = QVariant::fromValue(config).value<QJsonObject>();
    write_config(json);
}

void HrbConfigDb::update_config_from_db()
{
    auto json = readConfig(cs);
    config = QVariant::fromValue(json).value<HrbAppConfig>();
    config.setRunState(false);
    emit configChanged(config);
}
