#ifndef ABSTRACTDBVIEWER_H
#define ABSTRACTDBVIEWER_H


#include "mongo/BaseConfig.h"
#include "mongoqt/MongoCollection.h"
#include "base/ConfigSelector.h"
#include "base/RcRunId.h"
#include "MongoViewerConfig.h"

#include <QList>
#include <QMetaType>
#include <QString>

class AbstractDbViewer
{
public:
    virtual QList<QJsonObject> agregate_json(const MongoViewerConfig &config) = 0;
    virtual QMap<ConfigSelector, QJsonObject> agregate_cs_json(const MongoViewerConfig &config) = 0;
    virtual QMap<RcRunId, QJsonObject> agregate_ri_json(const MongoViewerConfig &config) = 0;
    virtual QList<ConfigSelector> get_config_selectors(const MongoViewerConfig &config) = 0;
    virtual QStringList get_program_types(const MongoViewerConfig &config) = 0;
    virtual QStringList get_program_indexes(const MongoViewerConfig &config) = 0;
    virtual QList<RcRunId> get_rc_run_ids(const MongoViewerConfig &config) = 0;
    virtual QStringList get_rc_program_type(const MongoViewerConfig &config) = 0;
};

#endif // ABSTRACTDBVIEWER_H
