#ifndef ANALYZERSTAT_H
#define ANALYZERSTAT_H

#include <QElapsedTimer>
#include <QMetaType>

#include "base/ClientIndex.h"

#include "EventSizePeriod.h"

struct AnalyzerStat {
    AnalyzerStat() : index(ClientIndex()) {}

    AnalyzerStat(ClientIndex _id):index(_id) {
        clear();
    }

    void clear() {
        totalSize = 0;
        corruptedSize = 0;
        badSync = 0;
        evSize = 0;
        evCnt = 0;
        period.newPeriod();
        lastEvNum = 0;
        lastSyncWord = 0;
    }

    // For every incoming record exept StartRun/StopRun
    void addEvent(quint32 size) {
        evSize += size;
        ++evCnt;
        period.addEvent(size);
    }

    ClientIndex index;
    quint64 totalSize; // total parsed size in bytes
    quint64 corruptedSize; // in bytes
    quint64 badSync; // increment on every badSync setting true (bad fragments)
    quint64 evSize; // of detected records
    quint64 evCnt; // of detected records
    EventSizePeriod period;
    quint32 lastEvNum;
    quint32 lastSyncWord;
};
Q_DECLARE_METATYPE(AnalyzerStat)

#endif // ANALYZERSTAT_H
