#include "EvBClientConfig.h"

#include <QDataStream>
#include <QDebug>

#include "params.h"

void EvBClientConfig::checkAndRepair()
{
    if(bufSize==0)
        bufSize = DATA_RING_SIZE;
    bufSize = std::max(bufSize, quint64(DATA_RING_SIZE_MIN));
    bufSize = std::min(bufSize, quint64(DATA_RING_SIZE_MAX));
}

QDebug operator<<(QDebug dbg, const EvBClientConfig &c)
{
    dbg << "EvBClientConfig{"
        << "client_index:" << c.index
        << "enabled:" << c.enabled
        << "bufSize:" << c.bufSize
        << "}";

    return dbg;
}

QDataStream &operator<<(QDataStream &out, const EvBClientConfig &r)
{
    out
            << r.index
            << r.enabled
            << r.bufSize;

    return out;
}

QDataStream &operator>>(QDataStream &in, EvBClientConfig &r)
{
    in
            >> r.index
            >> r.enabled
            >> r.bufSize;

    return in;
}
