#include "EvBConfigDb.h"
#include "base/config/ConfigSelector.h"
#include "EvBConfigConverter.h"

EvBConfigDb::EvBConfigDb(QObject *parent) :
    AbstractConfigDb(parent)
{
    AbstractConfigConverter<EvBConfig>::registerTypes();
}

void EvBConfigDb::update_config_from_db()
{
    auto conf_json = BaseConfig::readConfig(cs);
    config = QVariant::fromValue(conf_json).value<EvBConfig>();
    config.checkAndRepair();
    emit configChanged(config);
}

void EvBConfigDb::setConfig(const EvBConfig &newConfig)
{
    if(!initialized)
        return;
    if (newConfig == config)
        return;
    config = newConfig;

    config.checkAndRepair();

    auto json = QVariant::fromValue(config).value<QJsonObject>();
    write_config(json);
}
