//
//    Copyright 2016 Ilja Slepnev
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#include "TcpServerStats.h"

#include <QDebug>

//#include <boost/accumulators/statistics/rolling_mean.hpp>

TcpServerStats::TcpServerStats()
    : writeLatency(new StatsAccumulator(statsWindow))
{
    clear();
}

TcpServerStats::~TcpServerStats()
{
    delete writeLatency;
}

void TcpServerStats::clear()
{
    bytesSent=0;
}

void TcpServerStats::addLatencyValue(double d)
{
    writeLatency->add(d);
//    qInfo() << d;
}

double TcpServerStats::getMeanLatency() const
{
    return writeLatency->mean();
}
