#ifndef TLU16SFPMODELITEM_H
#define TLU16SFPMODELITEM_H

#include "base/DeviceIndex.h"

struct Tlu16SfpModelItem
{
    explicit Tlu16SfpModelItem() = default;
    ~Tlu16SfpModelItem() {
        qDeleteAll(children);
    }
    Tlu16SfpModelItem *child(int row) const { return children.value(row, nullptr); }
    Tlu16SfpModelItem *createChild() {
        auto child = new Tlu16SfpModelItem();
        child->dev = dev;
        child->parent = this;
        children.push_back(child);
        return child;
    }
    int childCount() const { return children.size();}
    int row() const {
        if(parent)
            return parent->children.indexOf(const_cast<Tlu16SfpModelItem*>(this));
        return 0;
    }

    DeviceIndex dev;
    int ch=-1;
    Tlu16SfpModelItem *parent = nullptr;
    QVector<Tlu16SfpModelItem *> children;
};
#endif // TLU16SFPMODELITEM_H
