#include "MscThresholdDialog.h"
#include "ui_MscThresholdDialog.h"
#include "MscThresholdModel.h"
#include "MscSignalRouter.h"

#include <QDebug>
#include <QTimer>

namespace {
    enum {COL_CFG_CH, COL_CFG_THR, COL_CFG_NUM};
}

MscThresholdDialog::MscThresholdDialog(QWidget *parent)
    : QDialog(parent)
    , ui(new Ui::MscThresholdDialog)
{
    ui->setupUi(this);
}

MscThresholdDialog::~MscThresholdDialog()
{
    delete ui;
}

void MscThresholdDialog::setModel(MscThresholdModel *model)
{
    ui->treeView->setModel(model);

    connect(model, &QAbstractItemModel::modelReset, [=, this]() {
          auto t = ui->treeView;
          for(int c=0; c<model->columnCount(); ++c)
              t->resizeColumnToContents(c);
          t->expandAll();
    });
}

void MscThresholdDialog::setConfig(const ConfigKey &config_key,
                                   const BaseDeviceAppConfig &newConfig)
{
    Q_UNUSED(config_key)
    if(config.has_value() && newConfig == config.value()) {
        return;
    }
    config = newConfig;
    auto &cfg = config.value();

    ui->device_empty_label->setVisible(cfg.knownConfigs.isEmpty());
    ui->treeView->setVisible(!cfg.knownConfigs.isEmpty());
}
