/*
**    Copyright 2014-2015 Ivan Filippov
**    Copyright 2014-2022 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "RcConfig.h"
#include "base/DeviceId.h"

#include <QDebug>
#include <QStringList>

DeviceIndex RcConfig::findVmeDeviceIndexBySerial(quint64 serial) const
{
    for (auto it = vmeTrigs.begin(); it != vmeTrigs.end(); ++it) {
        if (it.key().getSerial() == serial)
            return it.key();
    }
    return DeviceIndex();
}

int RcConfig::extTrigChannelCount() const
{
    switch (rcTrigConfig.index.getDevId()) {
    case  DEVICE_ID_U40VE_RC: return 1;
    case  DEVICE_ID_UT24VE: return 4;
    default: return 0;
    }
}
