#ifndef SLOWCONTROLDIALOG_H
#define SLOWCONTROLDIALOG_H

#include <QDialog>

#include <optional>
#include "SlowControlConfig.h"

namespace Ui {
class SlowControlDialog;
}

class SlowControlDialog : public QDialog
{
    Q_OBJECT

public:
    explicit SlowControlDialog(QWidget *parent = nullptr);
    ~SlowControlDialog();

signals: void slowControlConfigChanged(const SlowControlConfig &) const;
public slots: void setSlowControlConfig(const SlowControlConfig &newConfig);

public slots:
    void onSlowCntStatusUpdated(quint16 tcpPort, bool listening, bool portInUse);

private slots:
    void on_checkBoxEnabled_stateChanged(int en);
    void on_spinBoxPort_valueChanged(int port);

private:
    Ui::SlowControlDialog *ui;
    std::optional<SlowControlConfig> config;
    bool blockControl = false;
};

#endif // SLOWCONTROLDIALOG_H
