#ifndef TRCDEVICEGLOBAL_H
#define TRCDEVICEGLOBAL_H

#include "mstream-mreg-dev-global/MstreamMregDevGlobal.h"
#include "TrcStatus.h"

class TrcDevice;
class TrcDeviceConfig;
struct BaseDeviceAppConfig;

class TrcDeviceGlobal : public MstreamMregDevGlobal
{
    Q_OBJECT
public:
    explicit TrcDeviceGlobal(const DeviceIndex &index, QObject *parent = nullptr);
    TrcStatus getTrcDevStatus() const { return trcDevStatus; }

signals:
    void sendJsonBlock(const DeviceIndex &, const QByteArray &data) const;

public slots:
    void deviceStatusUpdated(const TrcStatus &status);

protected:
    virtual void postAddMStreamDump(MStreamDump *) override;

private:
    void onSpillStateUpdated(const TrcStatus &devSt);

private:
    TrcStatus trcDevStatus;
    bool pendingStatusSend = false;
    bool lookForStop = false;
    quint32 stopEvNum = 0;
};

#endif // TRCDEVICEGLOBAL_H
