#ifndef TRCSTATUS_H
#define TRCSTATUS_H

#include <QMetaType>
#include <QMap>

#include "ModularDeviceStatus.h"
#include "base/DeviceIndex.h"
#include "device-modules/TrcCore/PhysicalTrigger/PhysicalTriggerStatus.h"

struct TrcStatistic
{
    void clear() {
        evNumAll=0;
        evNumCandidateRun=0;
        evNumAccepted=0;
        timeValidLoss=0;
        rxCodeError=0;
        pllUnlockCnt=0;
    }

    quint64 evNumAll = 0;
    quint64 evNumCandidateRun = 0;
    quint64 evNumAccepted = 0;
    quint32 timeValidLoss = 0;
    quint32 rxCodeError = 0;
    quint32 pllUnlockCnt = 0;
};

struct TrcStatus : public ModularDeviceStatus
{
    explicit TrcStatus(const DeviceIndex &deviceIndex = {})
        : ModularDeviceStatus(deviceIndex) {}

    void clear() {
        statistic.clear();
        globEvNum.reset();
        phyTrig.clear();
    }

    std::optional<quint64> globEvNum;
    TrcStatistic statistic;
    PhysicalTriggerStatus phyTrig;
};
Q_DECLARE_METATYPE(TrcStatus)

#endif // TRCSTATUS_H
