#include "TrcMainWindow.h"
#include "TrcApp.h"
#include "TrcCore.h"

#include "base/app/RunGuard.h"
#include "base/Globals.h"
#include "mongo/PrintConfigMap.h"

int main(int argc, char *argv[])
{
    Globals::setDaqModuleType(DaqModule::Type::Trc);
    TrcApp daqApp(argc, argv);
    daqApp.init();

    if(daqApp.hasConfigListOpt())
        printConfigMap();

    RunGuard::runSingleOrExit();

    if(daqApp.isGuiApp()) {
        TrcMainWindow *mw(new TrcMainWindow);
        mw->show();
    }
    TrcCore core;

    return daqApp.exec();
}
