
#include "TtvxsMainWindow.h"
#include "base/app/DaqGuiApp.h"
#include "base/app/RunGuard.h"
#include "metric-sender/MetricSender.h"
#include "mongo/PrintConfigMap.h"
#include "base/Globals.h"

#include <iostream>

int main(int argc, char *argv[])
{
    Globals::setDaqModuleType(DaqModule::Type::Ttvxs);
    DaqGuiApp daqApp(argc, argv);
    daqApp.init();

    if(daqApp.hasConfigListOpt())
        printConfigMap();

    int res = 1;
    {
    RunGuard::runSingleOrExit();
    MetricSender::instance().install(); // FIXME: remove me
    {
        TtvxsMainWindow *mw = nullptr;
        if (daqApp.isGuiApp()) {
            mw = new TtvxsMainWindow;
            mw->show();
        }

        res = daqApp.exec();
        delete mw;
    }
    }
    return res;
}
