/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "DaqGuiApp_p.h"

#include <QApplication>

#include "DaqGuiApp.h"

DaqGuiAppPrivate::DaqGuiAppPrivate(int &argc, char *argv[], DaqGuiApp *p)
    : q_ptr(p)
{}

QCoreApplication *DaqGuiAppPrivate::createApplication(int &argc, char *argv[])
{
    Q_Q(const DaqGuiApp);
    if (q->option_no_gui)
        return new QCoreApplication(argc, argv);
    return new QApplication(argc, argv);
}
