#ifndef ABSTRACTCONFIGSAMPLE_H
#define ABSTRACTCONFIGSAMPLE_H

#include <QString>

class DeviceIndex;
class DaqModule;
class ClientIndex;
class ProgramIndex;
class RcRunId;
class ConfigSelector;
class ConfigurationName;
class ConfigIndexName;

class AbstractConfigSample
{
public:

    template<typename T>
    static void setSample(T *val)
    {
        *val = sample<T>();
    }
    template<typename T>
    static T sample();
};

// Base
template<>
QString AbstractConfigSample::sample<QString>();
template<>
bool AbstractConfigSample::sample<bool>();
template<>
quint8 AbstractConfigSample::sample<quint8>();
template<>
qint16 AbstractConfigSample::sample<qint16>();
template<>
quint16 AbstractConfigSample::sample<quint16>();
template<>
qint32 AbstractConfigSample::sample<qint32>();
template<>
quint32 AbstractConfigSample::sample<quint32>();
template<>
quint64 AbstractConfigSample::sample<quint64>();
template<>
qint64 AbstractConfigSample::sample<qint64>();
template<>
double AbstractConfigSample::sample<double>();

// AFI Core types
template<>
DeviceIndex AbstractConfigSample::sample<DeviceIndex>();
template<>
DaqModule AbstractConfigSample::sample<DaqModule>();
template<>
ClientIndex AbstractConfigSample::sample<ClientIndex>();
template<>
ProgramIndex AbstractConfigSample::sample<ProgramIndex>();
template<>
RcRunId AbstractConfigSample::sample<RcRunId>();
template<>
ConfigSelector AbstractConfigSample::sample<ConfigSelector>();
template<>
ConfigurationName AbstractConfigSample::sample<ConfigurationName>();
template<>
ConfigIndexName AbstractConfigSample::sample<ConfigIndexName>();

//class XXXXX;
//template<>
//XXXXX AbstractConfigSample::sample<XXXXX>();

#endif // ABSTRACTCONFIGSAMPLE_H
