/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "DaqModuleConverter.h"

#include "base/AbstractConfigConverter.h"

template<>
bool AbstractConfigConverter<DaqModule>::classIsObject()
{
    return false;
}

template<>
QJsonObject AbstractConfigConverter<DaqModule>::toJsonObject(const DaqModule &in)
{
    Q_UNUSED(in)
    Q_UNREACHABLE();
}

template<>
DaqModule AbstractConfigConverter<DaqModule>::fromJsonObject(const QJsonObject &in)
{
    Q_UNUSED(in)
    Q_UNREACHABLE();
}

template<>
QJsonValue AbstractConfigConverter<DaqModule>::toJsonValue(const DaqModule &in)
{
    return QJsonValue(in.toString());
}

template<>
DaqModule AbstractConfigConverter<DaqModule>::fromJsonValue(const QJsonValue &in)
{
    return DaqModule::fromString(in.toString());
}

template<>
void AbstractConfigConverter<DaqModule>::registerSubTypes()
{
#if (QT_VERSION < QT_VERSION_CHECK(6,0,0))
    if (QMetaType::hasRegisteredConverterFunction<QString, DaqModule>())
        return;
    qRegisterMetaTypeStreamOperators<DaqModule>();
    QMetaType::registerConverter<DaqModule, QString>(&DaqModule::toString);
    QMetaType::registerConverter<QString, DaqModule>(&DaqModule::fromString);
#endif
}
