/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "StatisticsDbUtil.h"

#include <QString>

#include "base/DeviceIndex.h"

QString StatisticsDbUtil::key(const QString &item, const DeviceIndex &index)
{
    return QString("%1[%2]").arg(item, index.getIdent());
}

QString StatisticsDbUtil::key(const QString &item, const DeviceIndex &index, int channel)
{
    return key(item, index) + QString("[%1]").arg(channel);
}
