/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef TEXTUTILS_H
#define TEXTUTILS_H

#include <QMap>
#include <QStringList>

template<typename K, typename V>
QString makeBasicHtmlTable(const QMap<K, V> &map)
{
    QStringList sl;
    for (auto it = map.begin(); it != map.end(); ++it) {
        sl <<"<tr><td>" << it.key() << "</td><td>" << it.value().toString() << "</td></tr>";
    }
    return "<table>" + sl.join("") + "</table>";
}

#endif // TEXTUTILS_H
