/*
**    Copyright 2021 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef THREADLATENCYMONITORPRIVATE_H
#define THREADLATENCYMONITORPRIVATE_H

#include <QDateTime>
#include <QObject>
#include <QVector>

class ThreadLatencyMonitorPrivate : public QObject
{
    Q_OBJECT
public:
    explicit ThreadLatencyMonitorPrivate(QObject *parent = nullptr);

private slots:
    void checkLoopLatency();
    void periodicJob();

private:
    void printStatistics() const;
    void reset();

    QDateTime loopTime;
    QVector<double> values;
};

#endif // THREADLATENCYMONITORPRIVATE_H
