#include "threadQuit.h"

#include <QCoreApplication>
#include <QDebug>
#include <QThread>

#if (QT_VERSION >= QT_VERSION_CHECK(4, 7, 0))

#include <QElapsedTimer>

bool threadQuiting(QThread *thread, int timeout, QElapsedTimer *timer)
{
    bool result = true;
    const bool localTimer = timer==nullptr;
    if(localTimer) {
        timer = new QElapsedTimer();
        timer->start();
    }

    while(thread->isRunning() && !timer->hasExpired(timeout)){
        QCoreApplication::processEvents(QEventLoop::ExcludeUserInputEvents, 50);
    }

    if(thread->isRunning()){
        result = false;
        qDebug()<<"thread isn't stopped";
        thread->terminate();
    }

    if(localTimer)
        delete timer;
    return result;
}

#else

bool threadQuiting(QThread *thread, int timeout)
{
    // TODO: add timer

    bool result = true;
    if(thread->isRunning()){
        result = false;
        qDebug()<<"thread isn't stopped";
        thread->terminate();
    }
    return result;
}

#endif // QT_VERSION
