/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "LldpDiscoveryFilter.h"

#include "LldpDiscovery.h"

void LldpDiscoveryFilter::lldpCacheUpdated(const LldpInfoCache &cache)
{
    if (filter.isEmpty()) {
        emit lldpCacheUpdatedFiltered(cache);
        return;
    }
    LldpInfoCache result;
    for (auto it = cache.begin(); it != cache.end(); ++it) {
        auto deviceId = it.value().getDeviceIndex().getDevId();
        if (filter.contains(deviceId))
            result.insert(it.key(), it.value());
    }
    emit lldpCacheUpdatedFiltered(result);
}
