/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef LLDPDISCOVERYFILTER_H
#define LLDPDISCOVERYFILTER_H

#include <QObject>
#include <QSet>

enum DeviceId : uint8_t;

class LldpInfoCache;

class LldpDiscoveryFilter : public QObject
{
    Q_OBJECT
public:
    LldpDiscoveryFilter(const QSet<DeviceId> &filter, QObject *parent = nullptr)
        : QObject(parent), filter(filter) {}
    explicit LldpDiscoveryFilter(QObject *parent = nullptr);

public slots:
    void lldpCacheUpdated(const LldpInfoCache &cache);

signals:
    void lldpCacheUpdatedFiltered(const LldpInfoCache &cache);

private:
    const QSet<DeviceId> filter;
};

#endif // LLDPDISCOVERYFILTER_H
