#ifndef ADCSPIADS52J90MODULE_H
#define ADCSPIADS52J90MODULE_H

#include "BaseDeviceModule.h"
#include "device-modules/AdcSpiBaseModule.h"

class AdcSpiAds52J90Module : public BaseDeviceModule<AdcSpiAds52J90Module>, public AdcSpiBaseModule
{
public:
    explicit AdcSpiAds52J90Module(const MregBusInterface &bus);

    static QList<AFI_SDB_ID> getSupportedSdbIds();
    virtual void post_init() override;

    bool setupAdc() override;
    bool setCustomPatternMode(bool mode) override;
    bool setCustomPattern(quint16 data) override;
    virtual bool supportPRBS() const override { return true; }
    virtual bool setPRBSMode(bool en) override;

private:
    bool spi_write(quint16 addr, quint16 data, quint16 device_mask = 0xFFFF);
    bool spi_read(quint16 addr, quint16 *result, quint16 device_mask);
    bool spi_test_impl(TestResult *result) override;
    bool spi_csb_check();
};

#endif // ADCSPIADS52J90MODULE_H
