/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef CROSSPOINTSWITCHCONFIG_H
#define CROSSPOINTSWITCHCONFIG_H

#include <QMetaType>
#include <QVector>

struct CrosspointSwitchConfig
{
    friend bool operator==(const CrosspointSwitchConfig &, const CrosspointSwitchConfig &) = default;
    quint16 get(quint16 i, quint16 maxOut) const
    {
        return out.value(i, (i%(maxOut/2)+maxOut/2));
    }

    QVector<quint16> out;
};
Q_DECLARE_METATYPE(CrosspointSwitchConfig)

#endif // CROSSPOINTSWITCHCONFIG_H
