/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef FLASHPROGSTATUS_H
#define FLASHPROGSTATUS_H

#include <QString>
#include "base/Severity.h"

class FlashProgStatus
{
public:
    friend bool operator==(const FlashProgStatus &, const FlashProgStatus &) = default;

    QString toString() const;
    Severity status() const;

    bool chip_valid = false;
    uint32_t chip_capacity_Mib = 0;
    bool addr4bMode = false;
    QString taskName;
    bool taskRunning = false;
    bool taskAborted = false;
    double progress = 0;
};

#endif // FLASHPROGSTATUS_H
