#ifndef MLINKCSRMODULE_H
#define MLINKCSRMODULE_H

#include "device-modules/BaseDeviceModule.h"

#include "MlinkCsrStatus.h"

class MlinkCsrModule : public BaseDeviceModule<MlinkCsrModule>
{
public:
    explicit MlinkCsrModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    virtual void post_init() override;

//    MlinkCsrStatus readStatus();
    MlinkCsrStatus getStatus() const { return status; }
    std::optional<MlinkCsrStatus> readStatus();

    bool detect();
    bool readDeviceId();
    bool readTemp();
    bool writeLiveMagic(quint16 value, quint16 *readback);
    bool readLiveMagic(quint16 *value);
    bool readFirmwareId();

private:
    enum class CsrType { Dig, Default};
    CsrType getCsrType() const;
    static CsrType getCsrType(DeviceId deviceId);
    bool readOneWireId();

    MlinkCsrStatus status;
};

#endif // MLINKCSRMODULE_H
