#ifndef TLUTTLIOCONTROLMODULE_H
#define TLUTTLIOCONTROLMODULE_H

#include "device-modules/BaseDeviceModule.h"

#include <optional>

#include "TluTtlIoControlConfig.h"
#include "TluTtlIoControlBuildParams.h"

class TluTtlIoControlModule : public BaseDeviceModule<TluTtlIoControlModule>
{
public:
    explicit TluTtlIoControlModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    bool writeConfig(const TluTtlIoControlConfig &config);
    std::optional<TluTtlIoControlConfig> getInitConfig() const {
        return initConfig;
    }
    std::optional<TluTtlIoControlBuildParams> getBuildParam() const {
        return buildParams;
    }

protected:
    void post_init() override;

private:
    std::optional<TluTtlIoControlConfig> readConfig();

    std::optional<TluTtlIoControlBuildParams> buildParams;
    std::optional<TluTtlIoControlConfig> initConfig;
};

#endif // TLUTTLIOCONTROLMODULE_H
