#ifndef ADCMPDTRIGDIALOG_H
#define ADCMPDTRIGDIALOG_H

#include <QDialog>

#include "fsm/FsmState.h"
#include "lib-common/BaseDeviceAppConfig.h"

class AdcMpdTrigModel;
class QAbstractItemModel;
class AdcMpdTrigSpinBoxDelegate;
class AdcMpdTrigPolarityDelegate;
class ConfigKey;

namespace Ui {
class AdcMpdTrigDialog;
}

class AdcMpdTrigDialog : public QDialog
{
    Q_OBJECT

public:
    explicit AdcMpdTrigDialog(QWidget *parent = nullptr);
    ~AdcMpdTrigDialog();
    AdcMpdTrigModel *getModel() const { return model; }

public slots:
    void setDeviceList(const DeviceIndexEnabledMap &devices_);
    void updateRemoteBlocking(bool remoteConnected) const;
    void setConfig(const ConfigKey &config_key, const BaseDeviceAppConfig &newConfig);
    void onFsmStateChange(const FsmState &state);

private slots:
    void onModelReset();

signals:
    void configChanged(const BaseDeviceAppConfig &config) const;
    void deviceListChanged(const DeviceIndexEnabledMap &);

private:
    void addDelegate(const QModelIndex &index);

    Ui::AdcMpdTrigDialog *ui;
    BaseDeviceAppConfig appConfig;
    AdcMpdTrigModel * const model;
    AdcMpdTrigSpinBoxDelegate * const thrSbDelegate;
    AdcMpdTrigSpinBoxDelegate * const adcSbDelegate;
    AdcMpdTrigPolarityDelegate * const polDelegate;
};

#endif // ADCMPDTRIGDIALOG_H
