#ifndef DEVICECHMODELITEM_H
#define DEVICECHMODELITEM_H

#include "base/DeviceIndex.h"

struct DeviceChModelItem
{
    explicit DeviceChModelItem(DeviceChModelItem *p = nullptr) : parent(p) {
        if(p)
            dev = p->dev;
    }
    ~DeviceChModelItem() {
        qDeleteAll(children);
    }
    DeviceChModelItem *child(int row) const { return children.value(row, nullptr); }
    void addChild(DeviceChModelItem *child) { children.push_back(child); }
    int childCount() const { return children.size();}
    int row() const {
        if(parent)
            return parent->children.indexOf(const_cast<DeviceChModelItem*>(this));
        return 0;
    }

    DeviceIndex dev;
    int ch=-1;
    DeviceChModelItem *parent;
    QVector<DeviceChModelItem *> children;
};

#endif // DEVICECHMODELITEM_H
