#ifndef HPTDCSTATUSMODEL_H
#define HPTDCSTATUSMODEL_H

#include <QAbstractItemModel>
#include <QDebug>
#include <QMetaType>

#include "base/DeviceIndexEnabled.h"
#include "device-modules/TdcCore/TdcCoreStatus.h"

#include "base/DeviceIndexEnabled.h"
#include "HptdcStatusModelItem.h"


class HptdcStatusModel : public QAbstractItemModel
{
    Q_OBJECT
public:
    HptdcStatusModel(QObject *parent = nullptr);
    QVariant data(const QModelIndex &index, int role) const override;
    QVariant headerData(int section, Qt::Orientation orientation,
                        int role) const override;

    QModelIndex index(int row, int column,
                      const QModelIndex &parent = QModelIndex()) const override;
    QModelIndex parent(const QModelIndex &index) const override;
    int rowCount(const QModelIndex &parent = QModelIndex()) const override;
    int columnCount(const QModelIndex &parent = QModelIndex()) const override;

    QModelIndex indexOf(const DeviceIndex &deviceIndex) const;

    // DeviceIndexEnabledMap subscribe
signals: void deviceListChanged(const DeviceIndexEnabledMap &);
public slots: void setDeviceList(const DeviceIndexEnabledMap &new_devices);

    void setHptdcStatusMap(const DeviceIndex &index, const TdcCoreStatus &status);

private:
    QVariant displayData(const QModelIndex &index) const;
    QVariant getForegroundData(const QModelIndex &index) const;
    QVariant fontData(const QModelIndex &index) const;
    inline HptdcStatusModelItem *getItemByIndex(const QModelIndex &index) const;
    void reset();

    HptdcStatusModelItem  * rootItem;
    DeviceIndexSet enabled_cache;
    QMap<DeviceIndex, TdcCoreStatus> hptdcStatusDeviceMap;
    int maxChipNum = 0;
};

#endif // HPTDCSTATUSMODEL_H
