#ifndef RCTRIGCONTROLWIDGET_H
#define RCTRIGCONTROLWIDGET_H

#include <QWidget>

#include "device-modules/RcTrig/RcTrigConfig.h"
#include "fsm/FsmState.h"

namespace Ui {
class RcTrigControlWidget;
}

class QLabel;
class QComboBox;

class RcTrigControlWidget : public QWidget
{
    Q_OBJECT

public:
    explicit RcTrigControlWidget(QWidget *parent = nullptr);
    virtual ~RcTrigControlWidget() override;
    void updateExtTrigGroup();

public slots:
    void setRcTrigCfg(const RcTrigConfig &ttlCfg);
    void onFsmStateChange(const FsmState &state);

private slots:
    // Trig Input
    void on_doubleSpinBoxTrigTimerFreq_valueChanged(double arg1);
    void on_doubleSpinBoxTrigRandomFreq_valueChanged(double arg1);
    void on_doubleSpinBoxTrigRandomDeadTime_valueChanged(double arg1);
    void on_checkBoxTrigIn_toggled(bool checked);
    void on_checkBoxTrigIn2_toggled(bool checked);
    void on_checkBoxTrigIn3_toggled(bool checked);
    void on_checkBoxTrigIn4_toggled(bool checked);
    void on_checkBoxTrigLvds_toggled(bool checked);
    void on_checkBoxTrigPeriod_toggled(bool checked);
    void on_checkBoxTrigRandom_toggled(bool checked);

    void on_radioButtonTrigOpen_toggled(bool open);

signals:
    void rcTrigCfgChanged(const RcTrigConfig &config);

private:
    void restoreGuiFromConfig();
    void setTrigSrcMask(quint16 mask, bool checked);

    Ui::RcTrigControlWidget *ui;
    RcTrigConfig cfg;
    int blockSignal=0;
};

#endif // RCTRIGCONTROLWIDGET_H
