/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "HistogrammConfigSample.h"

#include "HistMngrCfg.h"

template<>
HistId AbstractConfigSample::sample<HistId>()
{
    return static_cast<HistId>(rand()%(10));
}

template<>
HistGroupCfg AbstractConfigSample::sample<HistGroupCfg>()
{
    HistGroupCfg cfg;
    setSample(&cfg.hist_id);
    setSample(&cfg.hist_group_en);
    setSample(&cfg.show_fit);
    return cfg;
}

template<>
HistMngrCfg AbstractConfigSample::sample<HistMngrCfg>()
{
    HistMngrCfg cfg;

    setSample(&cfg.daq_module);
    setSample(&cfg.is_inl_enabled);
    setSample(&cfg.cur_hist_id);

    setSample(&cfg.cur_dev_index);
    setSample(&cfg.cur_ch);
    setSample(&cfg.curEdgeLead);
    setSample(&cfg.curEdgeTrail);
    setSample(&cfg.use_stop_ch);
    setSample(&cfg.stop_dev_index);
    setSample(&cfg.stop_ch);
    setSample(&cfg.stopEdgeLead);
    setSample(&cfg.stopEdgeTrail);

    setSample(&cfg.inl_hist_code_dens);
    setSample(&cfg.global_enabled);
    setSample(&cfg.tai_ts_window);
    setSample(&cfg.mw_min);
    setSample(&cfg.mw_max);
    setSample(&cfg.hitTimeEdgeLead);
    setSample(&cfg.hitTimeEdgeTrail);
    setSample(&cfg.log_y_axis);
    setSample(&cfg.hide_zero_bin);
    setSample(&cfg.ampl_hist_with_max);

    const int cnt_groups = 3 + rand()%10;
    for(int i=0; i<cnt_groups; ++i) {
        const auto &hCfg = sample<HistGroupCfg>();
        cfg.hist_groups[hCfg.hist_id] = hCfg;
    }

    setSample(&cfg.histExportPath);

    return cfg;
}
