#ifndef JSONTREEITEM_H
#define JSONTREEITEM_H

#include <QJsonValue>
#include <QList>

class JsonTreeItem
{
public:
    JsonTreeItem(JsonTreeItem * parent = nullptr):mParent(parent){}
    ~JsonTreeItem();
    static JsonTreeItem* createItem(const QJsonValue& value, JsonTreeItem * parent = nullptr);

    void appendChild(JsonTreeItem * item);
    JsonTreeItem *child(int row);
    JsonTreeItem *parent();
    int childCount() const;
    void clear();
    int row() const;
    void setKey(const QString& key);
    void setValue(const QString& value);
    void setType(const QJsonValue::Type& type);
    QString key() const;
    QString value() const;
    QJsonValue::Type type() const;

private:
    QString mKey;
    QString mValue;
    QJsonValue::Type mType;
    QList<JsonTreeItem*> mChilds;
    JsonTreeItem * const mParent;
};

#endif // JSONTREEITEM_H
