/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef DEVICESTATECONTROLLER_H
#define DEVICESTATECONTROLLER_H

#include <QObject>

class DeviceIndex;
class QtMregDevice;

class DeviceStateController : public QObject
{
    Q_OBJECT
public:
    explicit DeviceStateController(QtMregDevice *device, QObject *parent = nullptr);

    bool isConnected() const { return connected; }

signals:
    void deviceStateChanged(const DeviceIndex &, bool);

protected slots:
    void deviceConnected(const DeviceIndex &index);
    void deviceDisconnected(const DeviceIndex &index);

private:
    QtMregDevice * const device;
    bool connected = false;
};

#endif // DEVICESTATECONTROLLER_H
