/*
**    Copyright 2020 Ilja Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef RCRUNINFO_H
#define RCRUNINFO_H

#include <QString>
#include <QVariant>

#include "RunStates.h"
#include "base/RcRunId.h"

class RcRunInfo
{
public:
    RcRunId get_run_id() const { return id; }
    QVariant get_start_ev_num() const { return startEvNum; }
    QVariant get_stop_ev_num() const { return stopEvNum; }
    // QString get_run_index() const { return id.runIndex; }
    // int get_run_number() const { return id.runNumber; }
//    void set(const QString &index, int number, RUN_STATES state) {
//        setId(RcRunId(index, number));
//        setState(state);
//    }
    void resetStartEvNum() {
        startEvNum.clear();
    }
    void resetStopEvNum() {
        stopEvNum.clear();
    }
    void setId(const RcRunId &_id) {
        id = _id;
    }
    void setStartEvNum(QVariant evNum) {
        startEvNum = evNum;
    }
    void setStopEvNum(QVariant evNum) {
        stopEvNum = evNum;
    }

    explicit operator QString() const {
        return id.toString();
    }
private:
    RcRunId id;
    QVariant startEvNum;
    QVariant stopEvNum;
};

Q_DECLARE_METATYPE(RcRunInfo)

#endif // RCRUNINFO_H
