/*
**    Copyright 2010-2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef MREGDEVICEADCM_H
#define MREGDEVICEADCM_H

namespace mlink {

class MregDeviceAdcm
{
public:
    enum {
        // Control registers
        ADCM16_CTRL_REG           = 0x40,
        ADCM16_CTRL_DEFAULT     = 0x0000,

        ADCM16_WIN_REG            = 0x41,
        ADCM16_STATUS_REG         = 0x42, /* read-only */
        ADCM16_WIN_DEFAULT      = 0xFFFF,

        ADCM16_TRIGMULT_REG       = 0x43,
        ADCM16_SERIAL_ID_HI_REG   = 0x46, /* read-only */
        ADCM16_LIVE_MAGIC         = 0x48,
        ADCM16_CH_DPM_KS_REG      = 0x4A, /* read-only */
        ADCM16_TEMPERATURE_REG    = 0x4B, /* read-only */
        ADCM16_FW_VER_REG         = 0x4C, /* read-only */
        ADCM16_FW_REV_REG         = 0x4D, /* read-only */
        ADCM16_SERIAL_ID_REG      = 0x4E, /* read-only */

        REG_PCB_VERSION           = 0x55  // temporary hack
    };
};

} // namespace mlink

#endif // MREGDEVICEADCM_H
