
#ifndef REGIO_FRAME_UTIL_H
#define REGIO_FRAME_UTIL_H

#include <cstddef>

#include <QtGlobal>

class MlinkFrame
{
public:
    enum { // bit fields
        ML_FRAME_VALIDATE_OK = 0,
        ML_FRAME_VALIDATE_SYNC = 0x1,
        ML_FRAME_VALIDATE_LEN = 0x2,
        ML_FRAME_VALIDATE_CRC = 0x4,
    };
    MlinkFrame(const quint32 *frameData, size_t frameLength);
    bool isValid() const;
    int checkStructure() const;
    //! Print detailed raw frame contents
    void frame_print (bool rx_not_tx) const;
    void print_ctrlreq_frame ();
    void print_ctrlack_frame ();
    void print_status_frame ();

    static int checkStructure(const quint32 *frameData, size_t frameLength);
    static void swap_endian (quint32 *frameData, size_t frameLength);
    static void print_raw_frame(const quint32 *frameData, size_t frameLength);
    static quint32 ml_make_crc (const void *buf, int len);

protected:

private:
    // prohibit copy construct
    MlinkFrame();
    MlinkFrame(const MlinkFrame&);
    MlinkFrame &operator=(const MlinkFrame&);

    const quint32 * const f;
    const size_t len;
};

#endif /* REGIO_FRAME_UTIL_H */
