#ifndef MONGOCONSTS_H
#define MONGOCONSTS_H

#include <QString>
#include <QCoreApplication>
#include <QStandardPaths>

const QString COLLECTION_SAVED = "saved_config";
const QString COLLECTION_HISTORY = "history_config";
const QString COLLECTION_DEVICE = "device_config";
const QString COLLECTION_TEST = "test";

const QString HISTORY_RUN = "HISTORY_RUN";
const QString CONFIG_PATH = QStandardPaths::writableLocation(QStandardPaths::ConfigLocation);

const std::string DB = "daq_db";
constexpr static const char *DB_TEST = "daq_db";

constexpr static const uint connectTimeoutMS = 1000;
constexpr static const uint serverSelectionTimeoutMS = 1000;

//config document
//constexpr const char *k_config_selector = "config_selector";
constexpr const char *k_run_id = "run_id";
//constexpr const char *k_config = "config";
//constexpr const char *k_meta = "meta";

__attribute__((deprecated("ConfigSelector converter")))
constexpr static const char *program_type = "program_type";
__attribute__((deprecated("ConfigSelector converter")))
constexpr static const char *program_index = "program_index";
__attribute__((deprecated("ConfigSelector converter")))
constexpr static const char *configuration_name = "configuration_name";

__attribute__((deprecated("RcRunId converter")))
constexpr static const char *run_index = "run_index";
__attribute__((deprecated("RcRunId converter")))
constexpr static const char *run_number = "run_number";

constexpr static const char *_id = "_id";
constexpr static const char *$date = "$date";
constexpr static const char *$oid = "$oid";

#endif // MONGOCONSTS_H
