#ifndef RCPROGRAMSTATE_H
#define RCPROGRAMSTATE_H

#include <QMetaType>

#include "base/DeviceIndex.h"
#include "base/ClientIndex.h"
#include "fsm/FsmState.h"

struct RcDeviceState
{
    friend bool operator==(const RcDeviceState &, const RcDeviceState &) = default;

    DeviceIndex index;
    FsmState state;
};
Q_DECLARE_METATYPE(RcDeviceState)

struct RcProgramState
{
    friend bool operator==(const RcProgramState &, const RcProgramState &) = default;
    void print() const {
        print(*this);
    }
    void print(const RcProgramState &st, int i=0) const {
        qInfo() << QString("%1").arg(i, 4*i) << st.index << st.fsm;
        for(auto v : st.clients)
            print(v, i+1);
    }

    ClientIndex index;
    FsmState fsm = FsmState::Unknown;
    QMap<ClientIndex, RcProgramState> clients;
    QMap<DeviceIndex, RcDeviceState> devices;
};
Q_DECLARE_METATYPE(RcProgramState)

#endif // RCPROGRAMSTATE_H
